"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AnimatedNumber = void 0;
var React = _interopRequireWildcard(require("react"));
var _jsxRuntime = require("react/jsx-runtime");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
const AnimatedNumber = ({
  duration = 1000,
  value,
  formatValue = v => `${v}`
}) => {
  const [animatedValue, setAnimatedValue] = React.useState(0);
  const [animateOpt, setAnimateOpt] = React.useState({
    duration,
    toValue: 0,
    startTime: +new Date()
  });
  React.useEffect(() => {
    setAnimateOpt({
      duration,
      toValue: value,
      startTime: +new Date()
    });
  }, [duration, value]);
  React.useEffect(() => {
    if (animatedValue === animateOpt.toValue) return;
    const startTime = animateOpt.startTime;
    const endTime = startTime + animateOpt.duration;
    const now = +new Date();
    const endValue = animateOpt.toValue;
    const nums = (endTime - now) / 1000 * 30 - 2;
    const remaining = endValue - animatedValue;
    const inc = nums > 0 ? remaining / nums : remaining;
    let nextVal = animatedValue + inc;
    if (endTime - now < 50) {
      nextVal = endValue;
    }
    const t = requestAnimationFrame(() => {
      setAnimatedValue(nextVal);
    });
    return () => cancelAnimationFrame(t);
  }, [animateOpt, animatedValue]);
  return /*#__PURE__*/(0, _jsxRuntime.jsx)("span", {
    children: formatValue(animatedValue)
  });
};
exports.AnimatedNumber = AnimatedNumber;