"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.ChessBoard = void 0;
var _react = require("@emotion/react");
var React = _interopRequireWildcard(require("react"));
var _Square = _interopRequireDefault(require("./Square"));
var _Piece = _interopRequireDefault(require("./Piece"));
var _jsxRuntime = require("@emotion/react/jsx-runtime");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
/**
 *
 * ChessBoard
 *
 */
/** @jsxImportSource @emotion/react */

const ChessBoard = ({
  blackPieces,
  redPieces,
  movePiece,
  turn,
  kill,
  canDrop,
  readonly,
  darkMode
}) => {
  const allPieces = redPieces.concat(blackPieces);
  const renderSquare = i => {
    const x = i % 9;
    const y = Math.floor(i / 9);
    const pieces = allPieces.filter(p => p.live);
    const item = pieces.find(({
      position: {
        x: px,
        y: py
      }
    }) => px === x && py === y);
    const key = item ? (0, _jsxRuntime.jsx)(_Piece.default, {
      item: item,
      turn: turn,
      readonly: readonly,
      darkMode: darkMode
    }) : null;
    return (0, _jsxRuntime.jsx)("div", {
      css: (0, _react.css)`
          width: 60px;
          height: 60px;
          position: relative;
          background-color: transparent;
        `,
      children: (0, _jsxRuntime.jsx)(_Square.default, {
        piece: item,
        x: x,
        y: y,
        movePiece: movePiece,
        pieces: pieces,
        kill: () => {
          if (item) kill(item);
        },
        canDrop: canDrop,
        readonly: readonly,
        darkMode: darkMode,
        children: key
      })
    }, `key-${i}`);
  };
  const squares = [];
  for (let i = 0; i < 90; i += 1) {
    squares.push(renderSquare(i));
  }
  return (0, _jsxRuntime.jsxs)("div", {
    css: (0, _react.css)`
        width: 540px;
        height: 600px;
        display: flex;
        flex-wrap: wrap;
        position: relative;
      `,
    children: [squares, (0, _jsxRuntime.jsx)("div", {
      css: (0, _react.css)`
          position: absolute;
          top: 50%;
          left: 25%;
          margin-top: -30px;
          height: 60px;
          line-height: 60px;
          font-size: 24px;
          user-select: none;
        `,
      children: "\u695A \u6CB3"
    }), (0, _jsxRuntime.jsx)("div", {
      css: (0, _react.css)`
          position: absolute;
          top: 50%;
          right: 25%;
          margin-top: -30px;
          height: 60px;
          line-height: 60px;
          font-size: 24px;
          user-select: none;
        `,
      children: "\u6F22 \u754C"
    })]
  });
};
exports.ChessBoard = ChessBoard;
var _default = ChessBoard;
exports.default = _default;