"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var React = _interopRequireWildcard(require("react"));
var _reactDnd = require("react-dnd");
var _react2 = require("@emotion/react");
var _types = require("./types");
var _jsxRuntime = require("@emotion/react/jsx-runtime");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
/** @jsxImportSource @emotion/react */

const Piece = ({
  item,
  turn,
  readonly,
  darkMode
}) => {
  const [collected, drag, dragPreview] = (0, _reactDnd.useDrag)(() => ({
    type: _types.ChessPieceDraggalbeType,
    item,
    canDrag() {
      if (readonly) return false;
      return item.color === turn;
    },
    isDragging(monitor) {
      return monitor.getItem().id === item.id;
    },
    collect(monitor) {
      return {
        // You can ask the monitor about the current drag state:
        isDragging: monitor.isDragging()
      };
    }
  }));
  let itemColor = item.color;
  if (darkMode && itemColor === _types.ChessColor.Black) {
    itemColor = 'white';
  }
  return (0, _jsxRuntime.jsx)("div", {
    css: (0, _react2.css)`
        width: 50px;
        height: 50px;
        position: absolute;
        left: 50%;
        top: 50%;
        margin-top: -25px;
        margin-left: -25px;
        font-size: 30px;
        text-align: center;
        line-height: 50px;
        border: 1px solid ${darkMode ? 'white' : 'black'};
        border-radius: 50%;
        background-color: ${darkMode ? 'black' : 'white'};
        user-select: none;
        color: ${itemColor};
      `,
    ref: collected.isDragging ? dragPreview : drag,
    children: item.name
  });
};
var _default = Piece;
exports.default = _default;