"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var React = _interopRequireWildcard(require("react"));
var _reactDnd = require("react-dnd");
var _types = require("./types");
var _jsxRuntime = require("react/jsx-runtime");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
const Square = ({
  x,
  y,
  pieces,
  piece,
  movePiece,
  kill,
  canDrop,
  children,
  readonly,
  darkMode
}) => {
  const [collectedProps, drop] = (0, _reactDnd.useDrop)({
    accept: _types.ChessPieceDraggalbeType,
    canDrop(item) {
      return canDrop(item, {
        x,
        y
      }, pieces);
    },
    hover(_item, monitor) {
      monitor.isOver({
        shallow: true
      }); // eslint-disable-line
      // You will receive hover() even for items for which canDrop() is false
      monitor.canDrop(); // eslint-disable-line
    },
    drop(item, monitor) {
      if (monitor.didDrop()) {
        // If you want, you can check whether some nested
        // target already handled drop
        return;
      }

      // You can do something with it
      movePiece(item, {
        x,
        y
      });
      kill();

      // You can also do nothing and return a drop result,
      // which will be available as monitor.getDropResult()
      // in the drag source's endDrag() method
      return {
        moved: true
      };
    },
    collect(monitor) {
      return {
        isOver: monitor.isOver(),
        isOverCurrent: monitor.isOver({
          shallow: true
        }),
        isDropable: monitor.canDrop(),
        itemType: monitor.getItemType()
      };
    }
  });
  const bgColor = collectedProps.isDropable && !readonly ? piece ? 'red' : 'green' : 'transparent';
  const lineColor = darkMode ? 'white' : 'black';
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
    style: {
      width: '100%',
      height: '100%',
      backgroundColor: bgColor
    },
    ref: readonly ? null : drop,
    children: [/*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
      style: {
        height: '1px',
        width: [0, 8].includes(x) ? '50%' : '100%',
        backgroundColor: lineColor,
        transform: `translate(${x === 0 ? '30px' : 0}, 30px)`
      }
    }), /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
      style: {
        height: [0, 9].includes(y) || [4, 5].includes(y) && ![0, 8].includes(x) ? '50%' : '100%',
        width: '1px',
        backgroundColor: lineColor,
        transform: `translate(30px, ${y === 0 || y === 5 && ![0, 8].includes(x) ? '30px' : 0})`
      }
    }), children]
  });
};
var _default = Square;
exports.default = _default;